using OSMDatastructure;
using OSMDatastructure.Graph;
using Pathfinding;

namespace Server;

public class Server
{
    
    public static void Main(string[] args)
    {
        ConsoleWriter newConsole = new ConsoleWriter();
        Console.SetOut(newConsole);
        Console.SetError(newConsole);
       
        //RegionConverter.ConvertXMLToRegions("D:/stuttgart-regbez-latest.osm", "D:/stuttgart-regbez-latest");
        //RegionConverter.ConvertXMLToRegions("D:/map.osm", "D:/map");
        Console.WriteLine("Loaded");

        
        Coordinates start = new Coordinates(48.7933989f, 9.8301467f);
        Coordinates finish = new Coordinates(48.7906258f, 9.8355983f);
        OsmNode[] path = Pathfinder.CustomAStar("D:/map", start, finish, Tag.SpeedType.pedestrian).ToArray();
        Console.WriteLine("{0}\n", path[0].ToString());
        for (int i = 0; i < path.Length - 1; i++)
        {
            OsmNode n1 = path[i];
            OsmNode n2 = path[i + 1];
            OsmEdge? e = n1.GetEdgeToNode(n2);
            if(e != null)
                Console.WriteLine("{0}\n{1}", e.ToString(), n2.ToString());
            else
                Console.WriteLine("NO EDGE\n{0}", n2.ToString());
        }
        Console.WriteLine();
    }
}